## cp2k 2025.1

=== Makefile ===
#
# make -j 16 ssmp psmp
#
# will now perform a parallel build of 4 cp2k executables
#
SHELL = /bin/sh
#
# the home dir is taken from the current directory.
ifeq ($(CP2KHOME),)
CP2KHOME     := $(abspath $(shell pwd))
export CP2KHOME
endif

ARCH         := local
export VERSION=ssmp

MAKEFILE     := $(CP2KHOME)/Makefile
ARCHDIR      := $(CP2KHOME)/arch
DATA_DIR     := $(CP2KHOME)/data
MAINEXEDIR   := $(CP2KHOME)/exe
MAINLIBDIR   := $(CP2KHOME)/lib
MAINOBJDIR   := $(CP2KHOME)/obj
MAINTSTDIR   := $(CP2KHOME)/regtesting
PRECOMMITDIR := $(CP2KHOME)/obj/precommit
PRETTYOBJDIR := $(CP2KHOME)/obj/prettified
DOXIFYOBJDIR := $(CP2KHOME)/obj/doxified
TOOLSRC      := $(CP2KHOME)/tools
SRCDIR       := $(CP2KHOME)/src
EXEDIR       := $(MAINEXEDIR)/$(ARCH)
REVISION     := $(shell $(CP2KHOME)/tools/build_utils/get_revision_number $(SRCDIR))

EXTSDIR      := exts
EXTSHOME     := $(CP2KHOME)/$(EXTSDIR)
EXTSPACKAGES := $(shell cd $(EXTSHOME) ; find * -maxdepth 0 -type d | grep -v build_ )

PYTHON       := /usr/bin/env python3

# Common Targets ============================================================
default_target: all

# Discover programs =========================================================
ifeq ($(ALL_EXE_FILES),)
export ALL_EXE_FILES := $(sort $(shell $(TOOLSRC)/build_utils/discover_programs.py $(SRCDIR)))
endif
EXE_NAMES := $(basename $(notdir $(ALL_EXE_FILES)))

# Once we are down to a single version ======================================
# this only happens on stage 3 and 4
ifneq ($(ONEVERSION),)
MODDEPS = "lower"
include $(ARCHDIR)/$(ARCH).$(ONEVERSION)
LIBDIR  := $(MAINLIBDIR)/$(ARCH)/$(ONEVERSION)
PKGCONFIGDIR  := $(LIBDIR)/pkgconfig
PKGCONFIG  := $(PKGCONFIGDIR)/libcp2k.pc
LIBEXTSDIR := $(LIBDIR)/$(EXTSDIR)
OBJDIR  := $(MAINOBJDIR)/$(ARCH)/$(ONEVERSION)
OBJEXTSDIR := $(OBJDIR)/$(EXTSDIR)
OBJEXTSINCL := $(foreach dir,$(EXTSPACKAGES),-I'$(OBJEXTSDIR)/$(dir)')
TSTDIR     := $(MAINTSTDIR)/$(ARCH)/$(ONEVERSION)
ifneq ($(LD_SHARED),)
	ARCHIVE_EXT := .so
else
	ARCHIVE_EXT := .a
endif
include $(EXTSHOME)/Makefile.inc
endif

# Declare PHONY targets =====================================================
.PHONY: $(VERSION) $(EXE_NAMES) \
        dirs makedep default_target all \
        toolversions exts extversions extclean \
        libcp2k cp2k_shell pkgconfig python-bindings \
        pre-commit pre-commit-clean \
        pretty precommit precommitclean doxygenclean doxygen \
        fpretty fprettyclean \
        doxify doxifyclean \
        install clean realclean distclean help \
        test testbg testclean \
        data \
        $(EXTSPACKAGES)

# Discover files and directories ============================================
#
# File type is derived from name. Only the following extensions are supported:
#   .F    ->  Fortran
#   .c    ->  C
#   .h    ->  C header
#   .cu   ->  CUDA or HIP kernel

ALL_SRC_DIRS := $(shell find $(SRCDIR) -type d | awk '{printf("%s:",$$1)}')
ALL_PKG_FILES  = $(shell find $(SRCDIR) -name "PACKAGE")
OBJ_SRC_FILES  = $(shell cd $(SRCDIR); find . -name "*.F")
OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -name "*.c")

ifneq ($(filter nvcc hipcc, $(notdir $(OFFLOAD_CC))),)
OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -name "*.cu")
endif

# Begrudgingly tolerated because PyTorch has no C API.
OBJ_SRC_FILES += $(SRCDIR)/torch_c_api.cpp

# Included files used by Fypp preprocessor
INCLUDED_SRC_FILES = $(notdir $(shell find $(SRCDIR) -name "*.fypp"))

# Include also source files which won't compile into an object file
ALL_SRC_FILES  = $(strip $(subst $(NULL) .,$(NULL) $(SRCDIR),$(NULL) $(OBJ_SRC_FILES)))
ALL_SRC_FILES += $(shell find $(SRCDIR) -name "*.h")

ALL_OBJECTS        = $(addsuffix .o, $(basename $(notdir $(OBJ_SRC_FILES))))
ALL_EXE_OBJECTS    = $(addsuffix .o, $(EXE_NAMES))
ALL_NONEXE_OBJECTS = $(filter-out $(ALL_EXE_OBJECTS), $(ALL_OBJECTS))

# stage 1: Call make recursively with each element in $(VERSION) as a target,
#          The actual target is stored in ORIG_TARGET.
#          Make can then parallelize over multiple versions targets.
ifeq ($(ONEVERSION),)
ORIG_TARGET = default_target

fes:
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=graph

$(EXE_NAMES) all toolversions extversions extclean libcp2k cp2k_shell exts $(EXTSPACKAGES) python-bindings test testbg:
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=$@

# stage 2: Store the version target in $(ONEVERSION),
#          Call make recursively with $(ORIG_TARGET) as target.
$(filter-out sopt, popt, $(VERSION)):
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(ORIG_TARGET) ORIG_TARGET="" VERSION="" ONEVERSION=$@

sopt:
	@+echo "Version sopt is now an alias for ssmp with OMP_NUM_THREADS=1."
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(ORIG_TARGET) ORIG_TARGET="" VERSION="" ONEVERSION="ssmp"
popt:
	@+echo "Version popt is now an alias for psmp with OMP_NUM_THREADS=1."
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(ORIG_TARGET) ORIG_TARGET="" VERSION="" ONEVERSION="psmp"

else

# stage 3: Include arch-file, create dirs, and run makedep.py for given $(ONEVERSION).
#          Afterwards, call make recursively again with -C $(OBJDIR) and INCLUDE_DEPS=true
ifeq ($(INCLUDE_DEPS),)
$(EXE_NAMES): makedep | dirs exts
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(EXEDIR)/$@.$(ONEVERSION) INCLUDE_DEPS=true

all: makedep | dirs exts
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) all INCLUDE_DEPS=true

# compilation for testing happens here
test: dirs makedep all
	@$(TOOLSRC)/regtesting/print_environment.sh $(ARCH) $(ONEVERSION)
	@+$(MAKE) --no-print-directory -C $(TSTDIR) -f $(MAKEFILE) test INCLUDE_DEPS=true

testbg: dirs makedep all
	@+$(MAKE) --no-print-directory -C $(TSTDIR) -f $(MAKEFILE) testbg INCLUDE_DEPS=true

libcp2k: pkgconfig makedep | dirs exts
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(LIBDIR)/libcp2k$(ARCHIVE_EXT) INCLUDE_DEPS=true

python-bindings: libcp2k
	@cd $(SRCDIR)/start/python ; \
        env CC='$(CC)' LDSHARED='$(LD) -shared' CFLAGS='$(CFLAGS)' LDFLAGS='$(LDFLAGS) $(LDFLAGS_C) $(LIBS)' \
        $(PYTHON) setup.py build_ext \
        --build-temp="$(OBJDIR)/python" \
        --build-lib="$(LIBDIR)/python" \
        --library-dirs="$(LIBDIR)" \
        --libraries="$(patsubst -l%,%,$(filter -l%,$(LIBS)))"

exts: $(EXTSPACKAGES)

dirs:
	@mkdir -p $(OBJDIR)
	@mkdir -p $(OBJEXTSDIR)
	@mkdir -p $(LIBDIR)
	@mkdir -p $(PKGCONFIGDIR)
	@mkdir -p $(LIBEXTSDIR)
	@mkdir -p $(EXEDIR)
	@mkdir -p $(TSTDIR)

pkgconfig: dirs
	@echo "Writing pkg-config $(PKGCONFIG)"
	@echo "Name: libcp2k" > $(PKGCONFIG)
	@echo "Description: CP2K as a library" >> $(PKGCONFIG)
	@echo "URL: https://www.cp2k.org" >> $(PKGCONFIG)
	@echo "Version: $(REVISION)" >> $(PKGCONFIG)
	@echo "includedir=$(SRCDIR)/start" >> $(PKGCONFIG)
	@echo "Cflags: -I\$${includedir}" >> $(PKGCONFIG)
	@echo "libdir=$(LIBDIR)" >> $(PKGCONFIG)
	@echo "Libs: -L\$${libdir} -Wl,-rpath=\$${libdir} -lcp2k $(LDFLAGS) $(LIBS)" >> $(PKGCONFIG)

toolversions:
ifneq ($(FC),)
	@echo "=========== FC ($(ONEVERSION)) ==========="
ifeq (Cray,$(shell $(CC) -V 2>&1 | head -n1 | cut -d' ' -f1))
	$(FC) -V
else ifeq (IBM,$(shell $(CC) -qversion 2>&1 | head -n1 | cut -d' ' -f1))
	$(FC) -qversion
else
	$(FC) --version
endif
endif
ifneq ($(CC),)
	@echo "=========== CC ($(ONEVERSION)) ==========="
ifeq (Cray,$(shell $(CC) -V 2>&1 | head -n1 | cut -d' ' -f1))
	$(CC) -V
else ifeq (IBM,$(shell $(CC) -qversion 2>&1 | head -n1 | cut -d' ' -f1))
	$(CC) -qversion
else
	$(CC) --version
endif
endif
ifneq ($(OFFLOAD_CC),)
	@echo "========== OFFLOAD_CC ($(ONEVERSION)) =========="
	$(OFFLOAD_CC) --version
	@echo ""
endif
ifneq ($(AR),)
ifeq (Linux,$(shell uname -s))
	@echo "=========== AR ($(ONEVERSION)) ==========="
	$(firstword $(AR)) V
	@echo ""
endif
endif
	@echo "========== Make ($(ONEVERSION)) =========="
	$(MAKE) --version
	@echo ""
	@echo "========= Python ($(ONEVERSION)) ========="
	$(PYTHON) --version

else

# Force CP2K recompilations if exts are updated
$(ALL_OBJECTS): $(EXTSDEPS_MOD)
$(ALL_EXE_OBJECTS): $(EXTSDEPS_LIB)

# stage 4: Include $(OBJDIR)/all.dep, expand target all and libcp2k, and perform actual build.

ifeq ("$(ONEVERSION)","psmp")
all: $(foreach e, $(EXE_NAMES) cp2k_shell, $(EXEDIR)/$(e).$(ONEVERSION)) $(EXEDIR)/cp2k.popt
else ifeq ("$(ONEVERSION)","ssmp")
all: $(foreach e, $(EXE_NAMES) cp2k_shell, $(EXEDIR)/$(e).$(ONEVERSION)) $(EXEDIR)/cp2k.sopt
else
all: $(foreach e, $(EXE_NAMES) cp2k_shell, $(EXEDIR)/$(e).$(ONEVERSION))
endif
$(LIBDIR)/libcp2k$(ARCHIVE_EXT) : $(ALL_NONEXE_OBJECTS)

# Create always a cp2k.[ps]opt soft link for each cp2k.[ps]smp executable
$(EXEDIR)/cp2k.sopt: $(EXEDIR)/cp2k.ssmp
	cd $(EXEDIR); ln -sf cp2k.ssmp cp2k.sopt
$(EXEDIR)/cp2k.popt: $(EXEDIR)/cp2k.psmp
	cd $(EXEDIR); ln -sf cp2k.psmp cp2k.popt

$(EXEDIR)/cp2k_shell.$(ONEVERSION): $(EXEDIR)/cp2k.$(ONEVERSION)
	cd $(EXEDIR); ln -sf cp2k.$(ONEVERSION) cp2k_shell.$(ONEVERSION)

test:
	@$(CP2KHOME)/tests/do_regtest.py --workbasedir $(TSTDIR) $(EXEDIR) $(ONEVERSION) $(TESTOPTS)

testbg:
	@echo "testing: $(ONEVERSION) : full log in $(TSTDIR)/regtest.log "
	@$(CP2KHOME)/tests/do_regtest.py --workbasedir $(TSTDIR) $(EXEDIR) $(ONEVERSION) $(TESTOPTS) > $(TSTDIR)/regtest.log 2>&1
	@grep -e "Summary:" -e "Status:" $(TSTDIR)/regtest.log

endif
endif

OTHER_HELP += "test : run the regression tests"
OTHER_HELP += "testbg : run the regression tests in background"

OTHER_HELP += "toolversions : Print versions of build tools"

OTHER_HELP += "extversions : Print versions of external modules"
OTHER_HELP += "extclean : Clean build of external modules"

#   extract help text from doxygen "\brief"-tag
help:
	@echo "=================== Binaries ===================="
	@echo "all                         Builds all executables (default target)"
	@for i in $(ALL_EXE_FILES); do \
        basename  $$i | sed 's/^\(.*\)\..*/\1/' | awk '{printf "%-28s", $$1}'; \
        grep "brief" $$i | head -n 1 | sed 's/^.*\\brief\s*//'; \
        done
	@echo "libcp2k                     Builds CP2K as a single library archive"
	@echo "cp2k_shell                  Creates symlink for backward compatibility"
	@echo ""
	@echo "===================== Tools ====================="
	@printf "%s\n" $(TOOL_HELP) | awk -F ':' '{printf "%-28s%s\n", $$1, $$2}'
	@echo ""
	@echo "================= Other Targets ================="
	@printf "%s\n" $(OTHER_HELP) | awk -F ':' '{printf "%-28s%s\n", $$1, $$2}'
	@echo "help                         Print this help text"

#
# so far CP2K does not install, but give a hint to the user
#
install:
	@echo ""
	@echo "The CP2K executable is $(foreach v, $(VERSION), $(EXEDIR)/cp2k.$(v))"
	@echo ""
OTHER_HELP += "install : Print installation help"

#
# delete the intermediate files, but not the libraries and executables, or created directories.
# Most useful to save space on the disk or e.g. for recompiles with PGO that still needs the .gcda files in the objdir
#
# To avoid printing out all non-gcda files within a directory with 'make clean',
# a list of all non-gcda file extensions within a directory is first created with the get_extensions macro,
# and a wildcard expression is then used to remove the appropriate files
# cleaning stuff ============================================================
define get_extensions
	$(shell test -d $(1) && find $(1) -type f -name "*.*" ! -name "*.gcda" | sed 's|.*\.||' | sort -u)
endef
clean:
	@echo rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v))
	@$(foreach v, $(VERSION), $(foreach ext, $(call get_extensions, $(MAINOBJDIR)/$(ARCH)/$(v)/), $(shell rm -rf $(MAINOBJDIR)/$(ARCH)/$(v)/*.$(ext))))
	rm -rf $(foreach v, $(VERSION), $(MAINLIBDIR)/$(ARCH)/$(v))
OTHER_HELP += "clean : Remove intermediate object and mod files, but not the libraries and executables, for given ARCH and VERSION"

# The Intel compiler creates a corresponding .dbg file for each executable when static linking of the Intel MPI library is requested (flag -static_mpi)

=== src/CMakeLists.txt ===
#!-------------------------------------------------------------------------------------------------!
#!   CP2K: A general program to perform molecular dynamics simulations                             !
#!   Copyright 2000-2025 CP2K developers group <https://cp2k.org>                                  !
#!                                                                                                 !
#!   SPDX-License-Identifier: GPL-2.0-or-later                                                     !
#!-------------------------------------------------------------------------------------------------!

include(fypp-sources)
include(cp2k_utils)
include(GNUInstallDirs) # required to get a proper LIBDIR variable
include(CMakePackageConfigHelpers)
configure_file(base/base_uses.f90 base/base_uses.f90 @ONLY)

# =================================================================================================
# SOURCE FILE LISTS
# =================================================================================================

# do not worry about formatting or sorting. make pretty will fix this for you

# the sources files are split by directory which hopefully make the list a bit
# clearer. Any Fortran new file can be added to CP2K_SRCS_F list. the list
# sorted but it is *not* a requirement. C files should be added preferencially
# to CP2K_SRCS_C etc....
#
# The other option is to simply create a new list with the syntax list(APPEND
# MY_FOO foo.c foo.F foo.cu) and add this list to the list of files to compile.

list(
  APPEND
  CP2K_SRCS_F
  admm_dm_methods.F
  admm_dm_types.F
  admm_methods.F
  admm_types.F
  admm_utils.F
  almo_scf_diis_types.F
  almo_scf_env_methods.F
  almo_scf.F
  almo_scf_lbfgs_types.F
  almo_scf_methods.F
  almo_scf_optimizer.F
  almo_scf_qs.F
  almo_scf_types.F
  al_system_types.F
  atom_admm_methods.F
  atom_basis.F
  atom_electronic_structure.F
  atom_energy.F
  atom.F
  atom_fit.F
  atom_grb.F
  atomic_charges.F
  atom_kind_orbitals.F
  atom_operators.F
  atom_optimization.F
  atom_output.F
  atom_pseudo.F
  atom_set_basis.F
  atom_sgp.F
  atoms_input.F
  atom_types.F
  atom_upf.F
  atom_utils.F
  atom_xc.F
  auto_basis.F
  post_scf_bandstructure_methods.F
  soc_pseudopotential_methods.F
  soc_pseudopotential_utils.F
  basis_set_output.F
  beta_gamma_psi.F
  block_p_types.F
  bse_main.F
  bse_full_diag.F
  bse_iterative.F
  bse_print.F
  bse_properties.F
  bse_util.F
  bsse.F
  cell_methods.F
  colvar_methods.F
  colvar_utils.F
  commutator_rkinetic.F
  commutator_rpnl.F
  constraint_3x3.F
  constraint_4x6.F
  constraint_clv.F
  constraint.F
  constraint_fxd.F
  constraint_util.F
  constraint_vsite.F
  core_ae.F
  core_ppl.F
  core_ppnl.F
  cp2k_debug.F
  cp2k_info.F
  cp_control_types.F
  cp_control_utils.F
  cp_dbcsr_cholesky.F
  cp_dbcsr_cp2k_link.F
  cp_dbcsr_diag.F
  cp_dbcsr_operations.F
  cp_dbcsr_output.F
  cp_ddapc.F
  cp_ddapc_forces.F
  cp_ddapc_methods.F
  cp_ddapc_types.F
  cp_ddapc_util.F
  cp_eri_mme_interface.F
  cp_external_control.F
  parallel_gemm_api.F
  cp_realspace_grid_cube.F
  cp_realspace_grid_init.F
  cp_subsys_methods.F
  cp_symmetry.F
  cryssym.F
  csvr_system_types.F
  csvr_system_utils.F
  ct_methods.F
  ct_types.F
  debug_os_integrals.F
  deepmd_wrapper.F
  dft_plus_u.F
  dgemm_counter_types.F
  distribution_2d_types.F
  distribution_methods.F
  dkh_main.F
  dm_ls_chebyshev.F
  dm_ls_scf_create.F
  dm_ls_scf_curvy.F
  dm_ls_scf.F
  dm_ls_scf_methods.F
  dm_ls_scf_qs.F
  dm_ls_scf_types.F
  domain_submatrix_methods.F
  domain_submatrix_types.F
  eeq_data.F
  eeq_input.F
  eeq_method.F
  ec_efield_local.F
  ec_environment.F
  ec_env_types.F
  ec_external.F
  ec_methods.F
  ec_orth_solver.F
  ed_analysis.F
  efield_tb_methods.F
  efield_utils.F
  eip_environment.F
  eip_environment_types.F
  eip_silicon.F
  embed_environment.F
  embed_main.F
  embed_types.F
  energy_corrections.F
  environment.F
  eri_mme/eri_mme_error_control.F
  eri_mme/eri_mme_gaussian.F
  eri_mme/eri_mme_integrate.F
  eri_mme/eri_mme_lattice_summation.F
  eri_mme/eri_mme_test.F
  eri_mme/eri_mme_types.F
  eri_mme/eri_mme_util.F
  et_coupling.F
  et_coupling_proj.F
  et_coupling_types.F
  ewald_environment_types.F
  ewald_methods_tb.F
  ewald_pw_methods.F
  ewald_pw_types.F
  ewalds.F
  ewalds_multipole.F
  ewald_spline_util.F
  excited_states.F
  exclusion_types.F
  ex_property_calculation.F
  exstates_types.F
  extended_system_types.F
  external_potential_methods.F
  f77_interface.F
  farming_methods.F
  farming_types.F
  fermi_utils.F
  fist_efield_methods.F
  fist_efield_types.F
  fist_energy_types.F
  fist_environment.F
  fist_environment_types.F
  fist_force.F
  fist_intra_force.F
  fist_main.F
  fist_neighbor_list_control.F
  fist_neighbor_lists.F
  fist_neighbor_list_types.F
  fist_nonbond_env_types.F
  fist_nonbond_force.F
  fist_pol_scf.F
  force_env_methods.F
  force_env_types.F
  force_env_utils.F
  force_fields_all.F
  force_fields_ext.F
  force_fields.F
  force_fields_input.F
  force_fields_util.F
  force_field_types.F
  fp_methods.F
  fp_types.F
  free_energy_types.F
  generic_os_integrals.F
  gle_system_types.F
  global_types.F
  graphcon.F
  grid/grid_api.F
  group_dist_types.F
  grrm_utils.F
  gapw_1c_basis_set.F
  gw_communication.F
  gw_main.F
  gw_large_cell_gamma.F
  gw_small_cell_full_kp.F
  post_scf_bandstructure_types.F
  post_scf_bandstructure_utils.F
  gw_utils.F
  gw_integrals.F
  gw_kp_to_real_space_and_back.F
  hartree_local_methods.F
  hartree_local_types.F
  header.F
  hfx_admm_utils.F
  hfx_communication.F
  hfx_compression_methods.F
  hfx_derivatives.F
  hfx_energy_potential.F
  hfx_exx.F
  hfx_helpers.F
  hfx_libint_interface.F
  hfx_load_balance_methods.F
  hfx_pair_list_methods.F
  hfx_pw_methods.F
  hfx_ri.F
  hfx_ri_kp.F
  hfx_screening_methods.F
  hfx_types.F
  hirshfeld_methods.F
  hirshfeld_types.F
  input_constants.F
  input_cp2k_almo.F
  input_cp2k_atom.F
  input_cp2k_atprop.F
  input_cp2k_binary_restarts.F
  input_cp2k_check.F
  input_cp2k_colvar.F
  input_cp2k_constraints.F
  input_cp2k_dft.F
  input_cp2k_harris.F
  input_cp2k_print_dft.F
  input_cp2k_scf.F
  input_cp2k_as.F
  input_cp2k_opt.F
  input_cp2k_qs.F
  input_cp2k_se.F
  input_cp2k_xas.F
  input_cp2k_distribution.F
  input_cp2k_ec.F
  input_cp2k_eip.F
  input_cp2k_embed.F
  input_cp2k_exstate.F
  input_cp2k_external.F
  input_cp2k_field.F
  input_cp2k_force_eval.F
  input_cp2k_free_energy.F
  input_cp2k_global.F
  input_cp2k_hfx.F
  input_cp2k_kpoints.F
  input_cp2k_loc.F
  input_cp2k_ls.F
  input_cp2k_mixed.F
  input_cp2k_mm.F
  input_cp2k_motion_print.F
  input_cp2k_mp2.F
  input_cp2k_neb.F
  input_cp2k_negf.F
  input_cp2k_nnp.F
  input_cp2k_poisson.F
  input_cp2k_projection_rtp.F
  input_cp2k_properties_dft.F
  input_cp2k_pwdft.F
  input_cp2k_qmmm.F
  input_cp2k_read.F
  input_cp2k_resp.F
  input_cp2k_restarts_util.F
  input_cp2k_rsgrid.F
  input_cp2k_subsys.F
  input_cp2k_smeagol.F
  input_cp2k_tb.F
  input_cp2k_thermostats.F
  input_cp2k_transport.F
  input_cp2k_voronoi.F
  input_cp2k_xc.F
  input_optimize_basis.F
  input_optimize_input.F
  input_restart_force_eval.F
  input_restart_rng.F
  integration_grid_types.F
  iao_analysis.F
  iao_types.F
  ipi_driver.F
  ipi_environment.F
  ipi_environment_types.F
  ipi_server.F
  iterate_matrix.F
  kg_correction.F
  kg_environment.F
  kg_environment_types.F
  kg_tnadd_mat.F
  kg_vertex_coloring_methods.F
  kpoint_coulomb_2c.F
  kpoint_io.F
  kpoint_methods.F
  kpoint_transitional.F
  kpoint_types.F
  kpsym.F
  libgrpp_integrals.F
  libint_2c_3c.F
  libint_wrapper.F
  library_tests.F
  linesearch.F
  localization_tb.F
  lri_compression.F
  lri_environment_init.F
  lri_environment_methods.F
  lri_environment_types.F
  lri_forces.F
  lri_integrals.F
  lri_ks_methods.F
  lri_optimize_ri_basis.F
  lri_optimize_ri_basis_types.F
  ls_matrix_exp.F
  manybody_eam.F
  manybody_deepmd.F
  manybody_gal21.F
  manybody_gal.F
  manybody_allegro.F
  manybody_nequip.F
  manybody_potential.F
  manybody_quip.F
  manybody_siepmann.F
  manybody_tersoff.F
  mao_basis.F
  mao_methods.F
  mao_optimizer.F
  mao_types.F
  mao_wfn_analysis.F
  matrix_exp.F
  maxwell_solver_interface.F
  mdctrl_types.F
  metadynamics.F
  metadynamics_types.F
  metadynamics_utils.F
  metadyn_tools/graph_methods.F
  metadyn_tools/graph_utils.F
  min_basis_set.F
  minbas_methods.F
  minbas_wfn_analysis.F
  mixed_cdft_methods.F
  mixed_cdft_types.F
  mixed_cdft_utils.F
  mixed_energy_types.F
  mixed_environment.F
  mixed_environment_types.F
  mixed_environment_utils.F
  mixed_main.F
  mm_collocate_potential.F
  mm_mapping_library.F
  mode_selective.F
  molden_utils.F
  molecular_dipoles.F
  molecular_moments.F
  molecular_states.F
  mol_force.F
  molsym.F
  moments_utils.F
  motion_utils.F
  mp2_cphf.F
  mp2_direct_method.F
  mp2_eri.F
  mp2_eri_gpw.F
  mp2.F
  mp2_gpw.F
  mp2_gpw_method.F
  mp2_grids.F
  mp2_integrals.F
  mp2_laplace.F
  mp2_optimize_ri_basis.F
  mp2_ri_2c.F
  mp2_ri_gpw.F
  mp2_ri_grad.F
  mp2_ri_grad_util.F
  mp2_ri_libint.F
  mp2_setup.F
  mp2_types.F
  mscfg_methods.F
  mscfg_types.F
  mulliken.F
  negf_alloc_types.F
  negf_atom_map.F
  negf_control_types.F
  negf_env_types.F
  negf_green_cache.F
  negf_green_methods.F
  negf_integr_cc.F
  negf_integr_simpson.F
  negf_integr_utils.F
  negf_matrix_utils.F
  negf_methods.F
  negf_subgroup_types.F
  negf_vectors.F
  nnp_acsf.F
  nnp_environment.F
  nnp_environment_types.F
  nnp_force.F
  nnp_model.F
  local_gemm_api.F
  offload/offload_api.F
  optbas_fenv_manipulation.F
  optbas_opt_utils.F
  optimize_basis.F
  optimize_basis_types.F
  optimize_basis_utils.F
  optimize_dmfet_potential.F
  optimize_embedding_potential.F
  optimize_input.F
  outer_scf_control_types.F
  paw_proj_set_types.F
  pair_potential_coulomb.F
  pair_potential.F
  pair_potential_types.F
  pair_potential_util.F
  pao_input.F
  pao_io.F
  pao_linpot_full.F
  pao_linpot_rotinv.F
  pao_main.F
  pao_methods.F
  pao_ml_descriptor.F
  pao_ml.F
  pao_ml_gaussprocess.F
  pao_ml_neuralnet.F
  pao_model.F
  pao_optimizer.F
  pao_param_exp.F
  pao_param.F
  pao_param_equi.F
  pao_param_fock.F
  pao_param_gth.F
  pao_param_linpot.F
  pao_param_methods.F
  pao_potentials.F
  pao_types.F
  particle_methods.F
  paw_proj_set_types.F
  pexsi_interface.F
  pexsi_methods.F
  pexsi_types.F
  pilaenv_hack.F
  pme.F
  pme_tools.F
  population_analyses.F
  preconditioner_apply.F
  preconditioner.F
  preconditioner_makes.F
  preconditioner_solvers.F
  preconditioner_types.F
  qmmm_create.F
  qmmm_elpot.F
  qmmm_ff_fist.F
  qmmm_force.F
  qmmm_gaussian_data.F
  qmmm_gaussian_init.F
  qmmm_gaussian_input.F
  qmmm_gaussian_types.F
  qmmm_gpw_energy.F
  qmmm_gpw_forces.F
  qmmm_image_charge.F
  qmmm_init.F
  qmmm_links_methods.F
  qmmm_per_elpot.F
  qmmm_pw_grid.F
  qmmm_se_energy.F
  qmmm_se_forces.F
  qmmm_tb_coulomb.F
  qmmm_tb_methods.F
  qmmm_topology_util.F
  qmmm_types.F
  qmmm_types_low.F
  qmmm_util.F
  qmmmx_create.F
  qmmmx_force.F
  qmmmx_types.F
  qmmmx_update.F
  qmmmx_util.F
  qs_2nd_kernel_ao.F
  qs_active_space_methods.F
  qs_active_space_types.F
  qs_active_space_utils.F
  qcschema.F
  hdf5_wrapper.F
  sockets_interface.F
  qs_atomic_block.F
  qs_band_structure.F
  qs_basis_gradient.F
  qs_basis_rotation_methods.F
  qs_block_davidson_types.F
  qs_cdft_methods.F
  qs_cdft_opt_types.F
  qs_cdft_scf_utils.F
  qs_cdft_types.F
  qs_cdft_utils.F
  qs_charge_mixing.F
  qs_chargemol.F
  qs_charges_types.F
  qs_collocate_density.F
  qs_commutators.F
  qs_condnum.F
  qs_core_energies.F
  qs_core_hamiltonian.F
  qs_dcdr_ao.F
  qs_dcdr.F
  qs_dcdr_utils.F
  qs_density_matrices.F
  qs_density_mixing_types.F
  qs_dftb3_methods.F
  qs_dftb_coulomb.F
  qs_dftb_dispersion.F
  qs_dftb_matrices.F
  qs_dftb_parameters.F
  qs_dftb_types.F
  qs_dftb_utils.F
  qs_diis.F
  qs_diis_types.F
  qs_dispersion_nonloc.F
  qs_dispersion_d2.F
  qs_dispersion_d3.F
  qs_dispersion_d4.F
  qs_dispersion_pairpot.F
  qs_dispersion_types.F

=== exts/build_dbcsr/Makefile ===
# This Makefile is only used for the inclusion of the DBCSR library into CP2K.
# It is not supported by DBCSR development anymore.
############################################################
#### DO NOT CHANGE AS PART OF THE DBCSR DEVELOPMENT!!!! ####
############################################################
# CP2K team will update it, following the compilation flags suggested in the
# CP2K installation file.
# For this reason, this Makefile must be compatible with the CP2K
# compilation and tested within CP2K.
#
# The ARCH file can set the variables:
#
# CC  => C compiler, e.g. gcc or mpicc
# FC  => Fortran compiler, e.g. gfortran or mpifort
# LD  => Linker, e.g. gfortran or mpifort
# AR  => Archive command, e.g. ar -r
# CXXFLAGS  => C++ compilation flags
# CFLAGS    => C compilation flags
# FCFLAGS   => Fortran compilation flags
# LDFLAGS   => Linker flags
# LIBS      => Libraries
# ACC       => ACC can be nvcc (CUDA), mpicxx/mpicc or gcc/g++ (HIP), or mpicc/gcc (OpenCL)
# ACCFLAGS  => ACC flags
# USE_ACCEL => hip, cuda, or opencl
# GPUVER    =>
#          - for CUDA, possible values correspond to NVIDIA GPUs:
#            possible values are K20X, K40, K80, P100, V100
#          - for HIP, possible values correspond to NVIDIA and AMD GPUs:
#            possible values are K20X, K40, K80, P100, V100, Mi50, Mi100, Mi250
#          - for OpenCL, GPUVER maps to a file with tuned parameters:
#            src/acc/opencl/smm/params/tune_multiply_GPUVER.csv, or
#            src/acc/opencl/smm/tune_multiply.csv (default)
#
# Libraries for accelerator:
#    - e.g. for CUDA:   LIBS += -lstdc++ -lcudart -lnvrtc -lcuda -lcublas
#    - e.g. for HIP:    LIBS += -lstdc++ -lhiprtc -lhipblas
#    - e.g. for OpenCL: LIBS += -lOpenCL

#
SHELL = /bin/sh
#
# the home dir is taken from the current directory
#
DBCSRHOME    := $(CURDIR)
DBCSRCP2K    := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
MAKEFILE     := $(DBCSRCP2K)/Makefile
LIBDIR       := $(DBCSRHOME)/lib
OBJDIR       := $(DBCSRHOME)/obj
TOOLSDIR     := $(DBCSRHOME)/tools
FYPPEXE      := $(TOOLSDIR)/build_utils/fypp/bin/fypp
SRCDIR       := $(DBCSRHOME)/src
TESTSDIR     := $(DBCSRHOME)/tests
ARCHFILE     :=
CXXSTD       := -std=c++14

PYTHON       := /usr/bin/env python3

# Default Target ============================================================
LIBNAME      := dbcsr
LIBRARY      := lib$(LIBNAME)
default_target: $(LIBRARY)

# Read the version ==========================================================
include $(DBCSRHOME)/VERSION
ifeq ($(DATE),)
  DATE = "Development Version"
endif

# Read the configuration ====================================================
ifeq (,$(ARCHFILE))
$(error ARCH file must be provided: ARCHFILE=<CP2K ARCH file>)
endif
ifeq (, $(wildcard $(ARCHFILE)))
  $(error ARCH file `$(ARCHFILE)` not found)
endif
include $(ARCHFILE)

# Set the ARCH version ======================================================
ifeq ($(GPUVER),K20X)
  ARCH_NUMBER = 35
else ifeq ($(GPUVER),K40)
  ARCH_NUMBER = 35
else ifeq ($(GPUVER),K80)
  ARCH_NUMBER = 37
else ifeq ($(GPUVER),P100)
  ARCH_NUMBER = 60
else ifeq ($(GPUVER),V100)
  ARCH_NUMBER = 70
else ifeq ($(GPUVER),A100)
  ARCH_NUMBER = 80
else ifeq ($(GPUVER),A40)
  ARCH_NUMBER = 86
  override GPUVER := A100
else ifeq ($(GPUVER),H100)
  ARCH_NUMBER = 90
else ifeq ($(GPUVER),Mi50)
  ARCH_NUMBER = gfx906
else ifeq ($(GPUVER),Mi100)
  ARCH_NUMBER = gfx908
else ifeq ($(GPUVER),Mi250)
  ARCH_NUMBER = gfx90a
else ifeq (,$(ARCH_NUMBER))
ifneq ($(ACC),)
ifneq (opencl,$(USE_ACCEL))
  $(error Unknown ARCH_NUMBER since GPUVER="$(GPUVER)" is not recognized)
endif
endif
endif

# Set ACCFLAGS ==============================================================

# Adjust C++ standard level
override ACCFLAGS := $(CXXSTD) $(filter-out -std=c++11,$(ACCFLAGS))

# If compiling with nvcc
ifeq (cuda,$(USE_ACCEL))
  override ACCFLAGS := -D__CUDA -DARCH_NUMBER=$(ARCH_NUMBER) $(filter-out -D__CUDA,$(ACCFLAGS))
  CXXFLAGS := -D__CUDA $(filter-out -D__CUDA,$(CXXFLAGS))
  FCFLAGS := -D__CUDA $(filter-out -D__CUDA,$(FCFLAGS))
  #if "-arch" has not yet been set in ACCFLAGS
  ifeq (,$(findstring -arch,$(ACCFLAGS)))
    override ACCFLAGS := -arch sm_$(ARCH_NUMBER) $(ACCFLAGS)
  endif
  ifeq (,$(findstring -Xcompiler,$(ACCFLAGS)))
    override ACCFLAGS := $(ACCFLAGS) -Xcompiler="$(CXXFLAGS)"
  endif
# If compiling with hipcc
else ifeq (hip,$(USE_ACCEL))
  override ACCFLAGS := -D__HIP -DARCH_NUMBER=$(ARCH_NUMBER) $(filter-out -D__HIP,$(ACCFLAGS))
  CXXFLAGS := -D__HIP $(filter-out -D__HIP,$(CXXFLAGS))
  FCFLAGS := -D__HIP $(filter-out -D__HIP,$(FCFLAGS))
# OpenCL backend
else ifeq (opencl,$(USE_ACCEL))
  CFLAGS := -D__OPENCL $(filter-out -D__OPENCL $(CXXSTD),$(if $(ACCFLAGS),$(ACCFLAGS),$(CFLAGS)))
endif

# Set the configuration =====================================================
ifneq ($(LD_SHARED),)
  ARCHIVE_EXT := .so
else
  ARCHIVE_EXT := .a
endif

# Declare PHONY targets =====================================================
.PHONY : dirs makedep \
         default_target $(LIBRARY) \
         clean version

# Discover files and directories ============================================
ALL_SRC_DIRS       := $(shell find $(SRCDIR) -type d | awk '{printf("%s:",$$1)}')
LIBSMM_ACC_DIR     := $(shell cd $(SRCDIR) ; find . -type d -name "libsmm_acc")
LIBSMM_ACC_ABS_DIR := $(shell find $(SRCDIR) -type d -name "libsmm_acc")

ALL_PKG_FILES := $(shell find $(SRCDIR) -name "PACKAGE")
OBJ_SRC_FILES  = $(shell cd $(SRCDIR); find . ! -name "dbcsr_api_c.F" ! -name "dbcsr_tensor_api_c.F" -name "*.F")
OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -type f -name "*.c")

# Script used to create dependency/file which depends on GPUVER
ACC_MAKEDEP := $(wildcard $(LIBSMM_ACC_ABS_DIR)/../acc_makedep.sh)

# if compiling with GPU acceleration
ifneq ($(ACC),)
ifeq (cuda,$(USE_ACCEL))
  # All *.cpp files belong to the accelerator backend common between CUDA/HIP
  OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -type f ! -name "acc_cuda.cpp" ! -name "acc_hip.cpp" -name "*.cpp")
  OBJ_SRC_FILES += $(LIBSMM_ACC_DIR)/../cuda/acc_cuda.cpp
  # Exclude autotuning files
  OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -type f ! -name "tune_*_exe*_part*.cu" ! -name "tune_*_exe*_main*.cu"  -name "*.cu")
else ifeq (hip,$(USE_ACCEL))
  # All *.cpp files belong to the accelerator backend common between CUDA/HIP
  OBJ_SRC_FILES += $(shell cd $(SRCDIR); find . -type f ! -name "acc_cuda.cpp" ! -name "acc_hip.cpp" -name "*.cpp")
  OBJ_SRC_FILES += $(LIBSMM_ACC_DIR)/../hip/acc_hip.cpp
# OpenCL backend: OBJ_SRC_FILES already includes all *.c files
endif
endif

# Include also source files which won't compile into an object file
ALL_SRC_FILES  = $(strip $(subst $(NULL) .,$(NULL) $(SRCDIR),$(NULL) $(OBJ_SRC_FILES)))
ALL_SRC_FILES += $(shell find $(SRCDIR) -name "*.f90")
ALL_SRC_FILES += $(shell find $(SRCDIR) -name "*.h")
ALL_SRC_FILES += $(shell find $(SRCDIR) -name "*.hpp")

# stage 1: create dirs and run makedep.py.
#          Afterwards, call make recursively again with -C $(OBJDIR) and INCLUDE_DEPS=true
ifeq ($(INCLUDE_DEPS),)
$(LIBRARY): dirs makedep
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(LIBDIR)/$(LIBRARY)$(ARCHIVE_EXT) INCLUDE_DEPS=true DBCSRHOME=$(DBCSRHOME)
dirs:
	@mkdir -p $(OBJDIR)
	@mkdir -p $(LIBDIR)
version:
	@echo "DBCSR Version: "$(MAJOR)"."$(MINOR)"."$(PATCH)" ("$(DATE)")"
else
# stage 2: Include $(OBJDIR)/all.dep, expand target all, and get list of dependencies.

# Check if FYPP is available  ===============================================
ifeq (, $(shell which $(FYPPEXE) 2>/dev/null ))
  $(error No FYPP submodule available, please read README.md on how to properly download DBCSR)
endif

endif

clean:
	rm -f $(LIBSMM_ACC_ABS_DIR)/parameters.h $(LIBSMM_ACC_ABS_DIR)/smm_acc_kernels.h $(LIBSMM_ACC_ABS_DIR)/*.so
	rm -f $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/opencl_kernels.h
	rm -f $(TESTSDIR)/libsmm_acc_unittest_multiply.cpp
	rm -f $(TESTSDIR)/libsmm_acc_timer_multiply.cpp
	rm -rf $(OBJDIR)

# Libsmm_acc stuff ==========================================================
ifneq ($(ACC),)
ifneq (opencl,$(USE_ACCEL))
ACC_KERNEL := $(wildcard $(LIBSMM_ACC_ABS_DIR)/kernels/*.h)
ACC_PARAMS := $(wildcard $(LIBSMM_ACC_ABS_DIR)/parameters/parameters_$(GPUVER).json)
ACC_PARDEP := $(if $(ACC_MAKEDEP),$(shell $(ACC_MAKEDEP) $(LIBSMM_ACC_ABS_DIR)/.with_gpu $(GPUVER)))
$(LIBSMM_ACC_ABS_DIR)/parameters.h: $(LIBSMM_ACC_ABS_DIR)/generate_parameters.py $(ACC_PARAMS) $(ACC_PARDEP)
	cd $(LIBSMM_ACC_ABS_DIR); $(PYTHON) generate_parameters.py --gpu_version=$(GPUVER)
$(LIBSMM_ACC_ABS_DIR)/smm_acc_kernels.h: $(LIBSMM_ACC_ABS_DIR)/generate_kernels.py $(ACC_KERNEL)
	cd $(LIBSMM_ACC_ABS_DIR); $(PYTHON) generate_kernels.py
endif
endif

# automatic dependency generation ===========================================
MODDEPS     = "lower"
MAKEDEPMODE = "normal"
ifeq ($(HACKDEP),yes)
MAKEDEPMODE = "hackdep"
endif

# this happens at stage 1
makedep: $(ALL_SRC_FILES) $(ALL_PKG_FILES) dirs
ifeq ($(LD_SHARED),)
	@echo "Removing stale archives ... "
	@$(PYTHON) $(DBCSRCP2K)/check_archives.py $(firstword $(AR)) $(SRCDIR) $(LIBDIR)
endif
	@echo "Resolving dependencies ... "
	@$(PYTHON) $(DBCSRCP2K)/makedep.py $(OBJDIR)/all.dep dbcsr $(MODDEPS) $(MAKEDEPMODE) $(ARCHIVE_EXT) $(SRCDIR) $(OBJ_SRC_FILES)

# at stage 2, load the rules generated by makedep.py
ifeq ($(INCLUDE_DEPS), true)
  include $(OBJDIR)/all.dep
endif


# ================= Stuff need for compiling (stage 2) ======================
# These rules are executed in a recursive call to make -C $(OBJDIR)
# The change of $(CURDIR) allows to find targets without abs paths and vpaths.


### Slave rules ###
vpath %.F     $(ALL_SRC_DIRS)
vpath %.h     $(ALL_SRC_DIRS)
vpath %.hpp   $(ALL_SRC_DIRS)
vpath %.f90   $(ALL_SRC_DIRS)
vpath %.cu    $(ALL_SRC_DIRS)
vpath %.c     $(ALL_SRC_DIRS)
vpath %.cpp   $(ALL_SRC_DIRS)

# $(FCLOGPIPE) can be used to store compiler output, e.g. warnings, for each F-file separately.
# This is used e.g. by the convention checker.

FYPPFLAGS ?= -n

%.o: %.F
	$(PYTHON) $(FYPPEXE) $(FYPPFLAGS) $< $*.F90
	$(FC) -c $(FCFLAGS) -D__SHORT_FILE__="\"$(notdir $<)\"" -I'$(dir $<)' -I'$(SRCDIR)' $*.F90 $(FCLOGPIPE)

%.mod: %.o
	@true

%.o: %.c
	$(CC) -c $(CFLAGS) $<

ifneq ($(ACC),)
# if compiling CUDA/HIP backend
ifneq (opencl,$(USE_ACCEL))
%.o: %.cpp parameters.h smm_acc_kernels.h
	$(ACC) -c $(ACCFLAGS) -I'$(SRCDIR)' $<
# if compiling CUDA backend
ifeq (cuda,$(USE_ACCEL))
%.o: %.cu parameters.h smm_acc_kernels.h
	$(ACC) -c $(ACCFLAGS) -I'$(SRCDIR)' $<
calculate_norms.o: calculate_norms.cpp
	$(ACC) -c $(ACCFLAGS) -I'$(SRCDIR)' -x cu $<
acc_cuda.o: acc_cuda.cpp acc_cuda.h
	$(ACC) -c $(ACCFLAGS) -I'$(SRCDIR)' $<
# if compiling HIP backend
else
calculate_norms.o: calculate_norms.cpp
	$(OFFLOAD_CC) -D__HIP -c $(OFFLOAD_FLAGS) -I'$(SRCDIR)' $<
acc_hip.o: acc_hip.cpp acc_hip.h
	$(ACC) -c $(ACCFLAGS) -I'$(SRCDIR)' $<
endif

# if compiling OpenCL backend
else
OPENCL_KRNLGEN := $(LIBSMM_ACC_ABS_DIR)/../opencl/acc_opencl.sh
OPENCL_KERNELS := $(wildcard $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/kernels/*.cl)
OPENCL_DEFAULT := $(wildcard $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/tune_multiply.csv)
OPENCL_WITHGPU := $(wildcard $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/params/tune_multiply_$(GPUVER).csv)
OPENCL_PARAMS := $(if $(OPENCL_WITHGPU),$(OPENCL_WITHGPU),$(OPENCL_DEFAULT))
OPENCL_PARDEP := $(if $(ACC_MAKEDEP),$(shell $(ACC_MAKEDEP) $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/.with_gpu $(GPUVER)))
OPENCL_COMMON := $(wildcard $(LIBSMM_ACC_ABS_DIR)/../opencl/common/*.h)
$(LIBSMM_ACC_ABS_DIR)/../opencl/smm/opencl_kernels.h: $(OPENCL_KRNLGEN) $(OPENCL_KERNELS) $(OPENCL_COMMON) \
                                                      $(OPENCL_PARAMS) $(OPENCL_PARDEP)
	$(OPENCL_KRNLGEN) $(OPENCL_KERNELS) $(OPENCL_PARAMS) $@
opencl_libsmm.o: opencl_libsmm.c $(LIBSMM_ACC_ABS_DIR)/../opencl/smm/opencl_kernels.h
ifeq (Darwin,$(shell uname))
  LDFLAGS += -framework OpenCL
else

=== src/dbm/Makefile ===
PROJHOME := $(abspath $(dir $(lastword $(MAKEFILE_LIST))))
CP2KHOME := $(abspath $(PROJHOME)/../..)
ALL_HEADERS := $(shell find . -name "*.h") $(shell find ../offload/ -name "*.h")
ALL_OBJECTS := ../offload/offload_library.o \
        dbm_distribution.o \
        dbm_library.o \
        dbm_matrix.o \
        dbm_mempool.o \
        dbm_mpi.o \
        dbm_multiply.o \
        dbm_multiply_comm.o \
        dbm_multiply_cpu.o \
        dbm_shard.o

# Optimization level
ifeq (,$(filter-out 0,$(DBG)))
OPT ?= 3
else
OPT ?= 0
endif

# Optimization flag derived from OPT flag
OPTFLAG ?= -O$(patsubst O%,%,$(OPT))

CFLAGS := -fopenmp -g $(OPTFLAG) -march=native -Wall -Wextra -Wcast-qual

# Some additional flags when relying on default-CC
ifeq ($(CC),)
CFLAGS += -Wno-vla-parameter
endif

NVCC := $(shell which nvcc 2>/dev/null)
NVARCH := sm_70
NVFLAGS := -g $(OPTFLAG) -lineinfo -arch $(NVARCH) -Wno-deprecated-gpu-targets -Xcompiler "$(CFLAGS)" -D__OFFLOAD_CUDA

HIPCC := $(shell which hipcc 2>/dev/null)
HIPARCH := gfx90a
HIPFLAGS := -fPIE -g $(OPTFLAG) --offload-arch=$(HIPARCH) -Wall -Wextra -Werror -I${ROCM_PATH}/include -D__OFFLOAD_HIP -D__HIP_PLATFORM_AMD__ -D__HIP_PLATFORM_AMD__

# prefer NVCC or HIPCC over OpenCL
ifneq ($(NVCC)$(HIPCC),)
NVCC_PATH := $(if $(NVCC),$(wildcard $(dir $(NVCC))/..))
CUDA_FILE := $(wildcard $(NVCC_PATH)/../cuda/include/cuda.h)
CUDA_PATH := $(if $(CUDA_FILE),$(NVCC_PATH)/../cuda,$(NVCC_PATH))
CUDA_LIBS := $(if $(wildcard $(CUDA_PATH)/lib64),lib64,lib)
OPENCL := 0
endif
ifneq ($(OPENCL),0)
OPENCL_OFFLOAD := $(firstword $(wildcard $(CP2KHOME)/lib/*/*/exts/dbcsr/libdbcsr.a))
OPENCL_GENKRNL := $(PROJHOME)/dbm_multiply_opencl.cl.h
endif

# Make foundational runtimes available
LIBS += -fopenmp -ldl -lstdc++ -lc -lm


# Make BLAS/LAPACK available
ifneq ($(MKLROOT),)
LIBS += \
        -L$(MKLROOT)/lib/intel64 \
        -Wl,--start-group \
        -lmkl_gf_lp64 \
        -lmkl_core \
        -lmkl_sequential \
        -Wl,--end-group
else
LIBS += -lblas
endif

.PHONY : all clean

all: dbm_miniapp.x

clean:
	rm -fv *.o ../offload/*.o $(OPENCL_GENKRNL)

realclean: clean
	rm -fv *.x


# Enable OpenCL when DBCSR library was prebuilt (assume __DBCSR_ACC).
ifneq ($(OPENCL_OFFLOAD),)
OPENCL_SRC := $(PROJHOME)/dbm_multiply_opencl.cl
OPENCL_CMN := $(wildcard $(CP2KHOME)/exts/dbcsr/src/acc/opencl/common/*.h)
OPENCL_GEN := $(CP2KHOME)/exts/dbcsr/src/acc/opencl/acc_opencl.sh
ALL_HEADERS += $(OPENCL_GENKRNL)

ALL_OBJECTS += dbm_multiply_gpu.o dbm_multiply_opencl.o
CFLAGS += -I$(CP2KHOME)/exts/dbcsr -D__OFFLOAD_OPENCL -D__DBCSR_ACC
LIBS += $(OPENCL_OFFLOAD) -lgfortran

ifneq (Darwin,$(shell uname))
OPENCL_LIB := $(shell ldconfig -p 2>/dev/null | grep -m1 OpenCL | rev | cut -d' ' -f1 | rev)
ifeq (,$(OPENCL_LIB))
OPENCL_LIB := $(wildcard /usr/lib/x86_64-linux-gnu/libOpenCL.so.1)
endif
ifneq (,$(CUDA_PATH))
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(CUDA_PATH)/include
endif
ifeq (,$(wildcard $(OPENCL_LIB)))
LIBS += -L$(CUDA_PATH)/$(CUDA_LIBS)
LIBS += -Wl,-rpath=$(CUDA_PATH)/$(CUDA_LIBS)
endif
else ifneq (,$(wildcard $(OPENCL_ROOT)/include/CL/cl.h))
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(OPENCL_ROOT)/include
endif
LIBS += -L$(OPENCL_ROOT)/lib64
else ifneq (,$(wildcard $(OCL_ROOT)/include/CL/cl.h))
ifeq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(OCL_ROOT)/include
endif
LIBS += -L$(OCL_ROOT)/lib64
endif
# OPENCL_INC: directory containing CL/cl.h.
ifneq (,$(wildcard $(OPENCL_INC)))
CFLAGS += -I$(OPENCL_INC)
endif
# OPENCL_LIB: file/library to be linked
ifneq (,$(wildcard $(OPENCL_LIB)))
LIBS += $(OPENCL_LIB)
else
LIBS += -l:libOpenCL.so.1
endif
else # macOS
LIBS += -framework OpenCL
endif

$(OPENCL_GENKRNL): $(OPENCL_GEN) $(OPENCL_SRC) $(OPENCL_CMN)
	$(OPENCL_GEN) -b 6 -p "" $(OPENCL_SRC) $@


# Enable Cuda when nvcc compiler is present.
else ifneq ($(NVCC),)
ALL_OBJECTS += dbm_multiply_gpu.o dbm_multiply_gpu_kernel.o
CFLAGS += -I${CUDA_PATH}/include -D__OFFLOAD_CUDA
LIBS += -lcudart -lcuda -lcublas -L${CUDA_PATH}/$(CUDA_LIBS)
ifneq ($(wildcard $(NVCC_PATH)/../math_libs/$(CUDA_LIBS)),)
LIBS += -L$(NVCC_PATH)/../math_libs/$(CUDA_LIBS)
endif

%.o: %.cu $(ALL_HEADERS)
	cd $(dir $<); $(NVCC) -c $(NVFLAGS) $(notdir $<)


# Enable HIP/ROCm when hipcc compiler is present.
else ifneq ($(HIPCC),)
ALL_OBJECTS += dbm_multiply_gpu.o
CFLAGS += -I${ROCM_PATH}/include -D__OFFLOAD_HIP -D__HIP_PLATFORM_AMD__
LIBS += -L${ROCM_PATH}/lib -lamdhip64 -lhipfft -lhipblas -lrocblas

%.o: %.cu $(ALL_HEADERS)
	cd $(dir $<); $(HIPCC) -c $(HIPFLAGS) $(notdir $<)
endif


# Make LIBXSMM available
ifneq ($(LIBXSMMROOT),)
CFLAGS += -D__LIBXSMM -I$(LIBXSMMROOT)/include
LIBS += \
        $(LIBXSMMROOT)/lib/libxsmm.a $(LIBXSMMROOT)/lib/libxsmmext.a \
        -lpthread -lrt
endif


# Build with MPI when mpicc compiler is present.
ifneq ($(MPICC),)
%.o: %.c $(ALL_HEADERS)
	cd $(dir $<); $(MPICC) -c -std=c11 $(CFLAGS) -D__parallel $(notdir $<)

dbm_miniapp.x: dbm_miniapp.o $(ALL_OBJECTS)
	$(MPICC) $(CFLAGS) -o $@ $^ $(LIBS)


# Build without MPI otherwise.
else
%.o: %.c $(ALL_HEADERS)
	cd $(dir $<); $(CC) -c -std=c11 $(CFLAGS) $(notdir $<)

dbm_miniapp.x: dbm_miniapp.o $(ALL_OBJECTS)
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

endif
#EOF

=== src/grid/Makefile ===
.PHONY : all clean

all: grid_miniapp.x grid_unittest.x

clean:
	rm -fv *.o */*.o *.x ../offload/*.o

CFLAGS := -fopenmp -g -O3 -march=native -Wall -Wextra -Wno-vla-parameter
NVFLAGS := -g -O3 -lineinfo -arch sm_70 -Wno-deprecated-gpu-targets -Xcompiler "$(CFLAGS)" -D__OFFLOAD_CUDA
LIBS := -lm -lblas

ALL_HEADERS := $(shell find . -name "*.h") $(shell find ../offload/ -name "*.h")
ALL_OBJECTS := ../offload/offload_buffer.o \
        ../offload/offload_library.o \
        grid_replay.o \
        grid_task_list.o \
        common/grid_library.o \
        common/grid_basis_set.o \
        common/grid_sphere_cache.o \
        ref/grid_ref_task_list.o \
        ref/grid_ref_collocate.o \
        ref/grid_ref_integrate.o \
        ref/grid_ref_prepare_pab.o \
        cpu/grid_cpu_task_list.o \
        cpu/grid_cpu_collocate.o \
        cpu/grid_cpu_integrate.o \
        cpu/grid_cpu_prepare_pab.o \
        dgemm/grid_dgemm_context.o \
        dgemm/grid_dgemm_coefficients.o \
        dgemm/grid_dgemm_collocate.o \
        dgemm/grid_dgemm_integrate.o \
        dgemm/grid_dgemm_non_orthorombic_corrections.o \
        dgemm/grid_dgemm_utils.o \
        dgemm/grid_dgemm_collocation_integration.o \
        dgemm/grid_dgemm_context.o \
        dgemm/grid_dgemm_prepare_pab.o \
        dgemm/grid_dgemm_tensor_local.o

# Enable Cuda when nvcc compiler is present.
NVCC := $(shell which nvcc)
ifneq ($(NVCC),)
LIBS += -lcudart -lcuda -lcublas -L${CUDA_PATH}/lib64
CFLAGS += -I${CUDA_PATH}/include -D__OFFLOAD_CUDA
ALL_OBJECTS += gpu/grid_gpu_task_list.o \
        gpu/grid_gpu_collocate.o \
        gpu/grid_gpu_integrate.o

%.o: %.cu $(ALL_HEADERS)
	cd $(dir $<); $(NVCC) -c $(NVFLAGS) $(notdir $<)
endif

%.o: %.c $(ALL_HEADERS)
	cd $(dir $<); $(CC) -c -std=c11 $(CFLAGS) $(notdir $<)

grid_miniapp.x: grid_miniapp.o $(ALL_OBJECTS)
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

grid_unittest.x: grid_unittest.o $(ALL_OBJECTS)
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

#EOF

=== tools/Fun2D/Makefile ===
#
# requires a sufficiently recent gfortran and mpfr ....
#
# unfortunately, compiling can take ~1-2h
#
# if the openmp version is to be used, mpfr needs to be thread safe
# this requires an mpfr configured with './configure --enable-thread-safe ...'
#
YUKAWA   = -D__YUKAWA
T_C_G0   = -D__T_C_G0
DFLAGS   = $(T_C_G0)
CPP      = cpp
CPPFLAGS = -C -traditional $(DFLAGS)
FC       = gfortran-4.3 -ffree-line-length-512 -g -fopenmp -ffree-form $(DFLAGS)
# mpfr needs to be thread safe if used with OMP
LIBS     = -lmpfr -lgmp
# these flags can greatly affect the performance of the generated code
# but should only be used to compile the tester program, compilation is otherwise way too slow
FFLAGS   = -O3 -march=native -funroll-loops

.SUFFIXES: .f90 .x .o

%.o: %.f90
ifneq ($(CPP),)
	$(CPP) $(CPPFLAGS) $< > $*.f
	$(FC) -c $*.f
else
	$(FC) -c $<
endif

drvrec_mpfr.o : drvrec_mpfr.f90 mpfr.o mpfr.o functions.o padua2_mpfr.o
evalf.o : evalf.f90 mpfr_cutoff_gamma.o
functions.o : functions.f90 function_types.o mpfr_yukawa.o mpfr_cutoff_gamma.o mpfr.o mpfr.o
function_types.o : function_types.f90
kinds.o : kinds.f90
mpfr_cutoff_gamma.o : mpfr_cutoff_gamma.f90 mpfr.o mpfr.o
mpfr.o : mpfr.f90
mpfr_yukawa.o : mpfr_yukawa.f90 mpfr.o mpfr.o
padua2_mpfr.o : padua2_mpfr.f90 mpfr.o mpfr.o
recurse.o : recurse.f90 function_types.o
t_c_g0.o : t_c_g0.f90 kinds.o
yukawa.o : yukawa.f90 kinds.o

.PHONY: recurse tester test
recurse: recurse.x
tester: tester.x

#
# the test program depends on the choice of -DFLAGS
#
ifeq ($(DFLAGS),$(T_C_G0))
TESTEROBJ=kinds.o t_c_g0.o
else
TESTEROBJ=kinds.o yukawa.o
endif
tester.o: tester.f90 $(TESTEROBJ)
tester.x: tester.o $(TESTEROBJ)
	$(FC) $(FFLAGS) -o tester.x tester.o $(TESTEROBJ)

#
# drvrec_mpfr.x
#
DRVRECOBJ=mpfr.o functions.o padua2_mpfr.o function_types.o mpfr_yukawa.o mpfr_cutoff_gamma.o
drvrec_mpfr.x: drvrec_mpfr.o $(DRVRECOBJ)
	$(FC) -o drvrec_mpfr.x drvrec_mpfr.o $(DRVRECOBJ) $(LIBS)

#
# recurse.x
#
RECURSEOBJ=function_types.o
recurse.x: recurse.o $(RECURSEOBJ)
	$(FC) -o recurse.x recurse.o $(RECURSEOBJ)

#
# evalf is a quick hack
#
evalf.x: evalf.o mpfr_cutoff_gamma.o mpfr.o
	$(FC) -o drvrec_mpfr.x evalf.o mpfr_cutoff_gamma.o mpfr.o $(LIBS)

# generated files need special dependencies
t_c_g0.f90: recurse.x drvrec_mpfr.x
	./recurse.x > t_c_g0.f90
yukawa.f90: recurse.x drvrec_mpfr.x
	./recurse.x > yukawa.f90

test: tester.x
	./tester.x

clean:
	rm -f *.o *.x *.mod *.MOD *.f

realclean: clean
	rm -f *.dat *.in *.out t_c_g0.f90 fort.* yukawa.f90

=== tools/precommit/requirements.txt ===
black==24.3.0
blinker==1.7.0
click==8.1.7
cmake-format==0.6.13
cmakelang==0.6.13
Flask==3.0.0
gunicorn==22.0.0
itsdangerous==2.1.2
Jinja2==3.1.4
linkify-it-py==2.0.2
markdown-it-py==2.2.0
MarkupSafe==2.1.3
mdformat==0.7.17
mdformat-gfm==0.3.5
mdformat_frontmatter==2.0.1
mdformat_myst==0.1.5
mdformat_tables==0.4.1
mdit-py-plugins==0.3.5
mdurl==0.1.2
mypy-extensions==1.0.0
packaging==23.2
pathspec==0.11.2
platformdirs==4.0.0
ruamel.yaml==0.18.5
ruamel.yaml.clib==0.2.8
six==1.16.0
tomli==2.0.1
typing_extensions==4.8.0
uc-micro-py==1.0.2
Werkzeug==3.0.6

=== debian/changelog ===
cp2k (2025.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Don't run the autopkgtest on riscv64 where it does timeout.
    (Closes: #1102463)

 -- Adrian Bunk <bunk@debian.org>  Fri, 11 Apr 2025 11:36:53 +0300

cp2k (2025.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Optical BSE spectra
    + Real-time Bethe-Salpeter Propagation
    + Harris and EHT methods including linear-scaling solver
    + RPA based SIGMA Functionals
    + Smeared occupation TDA
  * debian/patches/remove_youtube_links_from_docs.patch: Refreshed.
  * debian/control (Build-Depends): Added python3-sphinxcontrib-mermaid and
    python3-sphinx-reredirects.
  * debian/rules (override_dh_auto_build): Build heavy cross-referencing parts
    of the documentation only on amd64.

 -- Michael Banck <mbanck@debian.org>  Sat, 05 Apr 2025 11:59:21 +0200

=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: bc,
               bison,
               debhelper (>= 10),
               default-jre-headless,
               flex,
               python3,
               python3-lxml,
               python3-myst-parser,
               python3-sphinxcontrib-mermaid,
               python3-sphinx-reredirects,
               python3-sphinx-rtd-theme,
               gfortran,
               libblas-dev,
               libdbcsr-dev (>= 2.6.0),
               libelpa-dev (>= 2022.11.001-1),
               libfftw3-dev,
               libint2-dev (>= 2.6.0-11),
               liblapack-dev,
               libsaxonb-java,
               libscalapack-mpi-dev (>= 2),
               libsymspg-dev,
               libxc-dev (>= 5.1.0),
               mpi-default-dev,
	       pkg-config
Standards-Version: 4.4.1
Homepage: http://www.cp2k.org
Vcs-Browser: https://salsa.debian.org/debichem-team/cp2k
Vcs-Git: https://salsa.debian.org/debichem-team/cp2k.git
Rules-Requires-Root: no

Package: cp2k
Architecture: any
Depends: cp2k-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-initio molecular
 dynamics (AIMD) simulations.
 .
 CP2K is optimized for the mixed Gaussian and Plane-Waves (GPW) method based on
 pseudopotentials, but is able to run all-electron or pure plane-wave/Gaussian
 calculations as well. Features include:
 .
 Ab-initio Electronic Structure Theory Methods using the QUICKSTEP module:
 .
  * Density-Functional Theory (DFT) energies and forces
  * Hartree-Fock (HF) energies and forces
  * Moeller-Plesset 2nd order perturbation theory (MP2) energies and forces
  * Random Phase Approximation (RPA) energies
  * Gas phase or Periodic boundary conditions (PBC)
  * Basis sets include various standard Gaussian-Type Orbitals (GTOs), Pseudo-
    potential plane-waves (PW), and a mixed Gaussian and (augmented) plane wave
    approach (GPW/GAPW)
  * Norm-conserving, seperable Goedecker-Teter-Hutter (GTH) and non-linear core
    corrected (NLCC) pseudopotentials, or all-electron calculations
  * Local Density Approximation (LDA) XC functionals including SVWN3, SVWN5,
    PW92 and PADE
  * Gradient-corrected (GGA) XC functionals including BLYP, BP86, PW91, PBE and
    HCTH120 as well as the meta-GGA XC functional TPSS
  * Hybrid XC functionals with exact Hartree-Fock Exchange (HFX) including
    B3LYP, PBE0 and MCY3
  * Double-hybrid XC functionals including B2PLYP and B2GPPLYP
  * Additional XC functionals via LibXC
  * Dispersion corrections via DFT-D2 and DFT-D3 pair-potential models
  * Non-local van der Waals corrections for XC functionals including B88-vdW,
    PBE-vdW and B97X-D
  * DFT+U (Hubbard) correction
  * Density-Fitting for DFT via Bloechl or Density Derived Atomic Point Charges
    (DDAPC) charges, for HFX via Auxiliary Density Matrix Methods (ADMM) and
    for MP2/RPA via Resolution-of-identity (RI)
  * Sparse matrix and prescreening techniques for linear-scaling Kohn-Sham (KS)
    matrix computation
  * Orbital Transformation (OT) or Direct Inversion of the iterative subspace
    (DIIS) self-consistent field (SCF) minimizer
  * Local Resolution-of-Identity Projector Augmented Wave method (LRIGPW)
  * Absolutely Localized Molecular Orbitals SCF (ALMO-SCF) energies for linear
    scaling of molecular systems
  * Excited states via time-dependent density-functional perturbation theory
    (TDDFPT)
 .
 Ab-initio Molecular Dynamics:
 .
  * Born-Oppenheimer Molecular Dynamics (BOMD)
  * Ehrenfest Molecular Dynamics (EMD)
  * PS extrapolation of initial wavefunction
  * Time-reversible Always Stable Predictor-Corrector (ASPC) integrator
  * Approximate Car-Parrinello like Langevin Born-Oppenheimer Molecular Dynamics
    (Second-Generation Car-Parrinello Molecular Dynamics (SGCP))
 .
 Mixed quantum-classical (QM/MM) simulations:
 .
  * Real-space multigrid approach for the evaluation of the Coulomb
    interactions between the QM and the MM part
  * Linear-scaling electrostatic coupling treating of periodic boundary
    conditions
  * Adaptive QM/MM
 .
 Further Features include:
 .
  * Single-point energies, geometry optimizations and frequency calculations
  * Several nudged-elastic band (NEB) algorithms (B-NEB, IT-NEB, CI-NEB, D-NEB)
    for minimum energy path (MEP) calculations
  * Global optimization of geometries
  * Solvation via the Self-Consistent Continuum Solvation (SCCS) model
  * Semi-Empirical calculations including the AM1, RM1, PM3, MNDO, MNDO-d, PNNL
    and PM6 parametrizations, density-functional tight-binding (DFTB) and
    self-consistent-polarization tight-binding (SCP-TB), with or without
    periodic boundary conditions
  * Classical Molecular Dynamics (MD) simulations in microcanonical ensemble
    (NVE) or canonical ensmble (NVT) with Nose-Hover and canonical sampling
    through velocity rescaling (CSVR) thermostats
  * Metadynamics including well-tempered Metadynamics for Free Energy
    calculations
  * Classical Force-Field (MM) simulations
  * Monte-Carlo (MC) KS-DFT simulations
  * Static (e.g. spectra) and dynamical (e.g. diffusion) properties
  * ATOM code for pseudopotential generation
  * Integrated molecular basis set optimization
 .
 CP2K does not implement conventional Car-Parrinello Molecular Dynamics (CPMD).

Package: cp2k-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Ab Initio Molecular Dynamics (data files)
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations.
 .
 This package contains basis sets, pseudopotentials and force-field parameters.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/mpi-default-dev/debian_defaults

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_BUILD_ARCH), i386)
    export FFTW3_ALIGN=-D__FFTW3_UNALIGNED
else
    export FFTW3_ALIGN=
endif

export LIB_SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export LIB_BLACS=$(LIB_SCALAPACK)
export LIB_MPI=$(shell pkg-config mpi-fort --libs)
export LIB_ELPA=-lelpa
export INC_ELPA=-I/usr/include/elpa/modules/ -I/usr/include/elpa/elpa/
export DEF_ELPA=-D__ELPA=202111
export OMPI_MCA_orte_rsh_agent=/bin/false
export CP2K_DATA_DIR=$(CURDIR)/data

# Upstream makefile contains lots of @ which make it impossible to debug
export MAKEFLAGS += --trace

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export MAKEFLAGS += -j$(NUMJOBS)
endif

# As the cross-referencing takes a lot time and memory, only include that on
# amd64. Drop -W from $SPHINXOPTS elsewhere to surpress missing reference
# warnings.
ifeq ($(DEB_BUILD_ARCH), amd64)
  SPHINX_BUILD = ./generate_input_reference.py ./cp2k_input.xml && make html SPHINXOPTS="-W -n --keep-going --jobs $(NUMJOBS)"
else
  SPHINX_BUILD = make html SPHINXOPTS="-n --keep-going --jobs $(NUMJOBS)"
endif

PLATFORM=Linux
ARCH=`uname -m`
FORT_C_NAME=gfortran
VERSION=psmp
PYTHON=python3

#cmake -DCP2K_ENABLE_REGTESTS=YES -DCP2K_USE_LIBINT2=YES -DCP2K_USE_LIBXC=YES -DCP2K_USE_SPGLIB=YES -DCP2K_USE_ELPA=YES -DCP2K_ENABLE_ELPA_OPENMP_SUPPORT=NO -DCP2K_ELPA_LINK_LIBRARIES=-lelpa -DCP2K_ELPA_INCLUDE_DIRS=/usr/include/elpa -DCP2K_SCALAPACK_LINK_LIBRARIES=-lscalapack-openmpi ..

%:
	dh $@ 

override_dh_auto_clean:
	cd arch && ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).$(VERSION)		   \
		$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).$(VERSION)
	+$(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME)		   \
		VERSION=$(VERSION) distclean
	cd docs && rm -rf CP2K_INPUT _build && rm -f cp2k_input.xml CP2K_INPUT.md
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	rm -rf LAST* TEST*
	dh_auto_clean

override_dh_auto_build:
	cd arch && ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).$(VERSION)		    \
		$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).$(VERSION)
	+$(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) 		    \
		VERSION=$(VERSION) PYTHON=$(PYTHON) all
	# The doc build needs the built executable for the input reference, so
	# cannot be done in a build-indep section
	cd docs && \
		$(CURDIR)/exe/*/cp2k.$(VERSION) --xml && \
		$(SPHINX_BUILD)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	chmod +x tools/regtesting/do_regtest
	(cd tools/regtesting; ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) ./do_regtest \
		-config ../../debian/regtest.config                                 \
		-restrictdir ATOM/regtest-2                                         \
		-restrictdir DFTB/regtest-nonscc                                    \
		-restrictdir FARMING/regtest-1                                      \
		-restrictdir FE/regtest-2                                           \
		-restrictdir Fist/regtest-11                                        \
		-restrictdir LIBTEST                                                \
		-restrictdir MC/regtest                                             \
		-restrictdir NEB/regtest-1                                          \
		-restrictdir optimize_input/regtest-1                               \
		-restrictdir QMMM/QS/regtest-2-erf                                  \
		-restrictdir QMMM/QS/regtest-4                                      \
		-restrictdir QMMM/QS/regtest-gapw                                   \
		-restrictdir QMMM/QS/regtest-lrigpw                                 \
		-restrictdir QMMM/SE/regtest_2                                      \
		-restrictdir QMMM/DFTB/regtest                                      \
		-restrictdir QS/regtest-all-electron                                \
		-restrictdir QS/regtest-almo-eda                                    \
		-restrictdir QS/regtest-cdft-3-1                                    \
		-restrictdir QS/regtest-dm-ls-scf-4                                 \
		-restrictdir QS/regtest-double-hybrid-2                             \
		-restrictdir QS/regtest-elpa                                        \
		-restrictdir QS/regtest-fftw                                        \
		-restrictdir QS/regtest-gapw-2                                      \
		-restrictdir QS/regtest-gpw-2-1                                     \
		-restrictdir QS/regtest-hfx-periodic                                \
		-restrictdir QS/regtest-hfx-stress                                  \
		-restrictdir QS/regtest-hirshfeld                                   \
		-restrictdir QS/regtest-hybrid-1                                    \
		-restrictdir QS/regtest-libxc                                       \
		-restrictdir QS/regtest-linearscaling                               \
		-restrictdir QS/regtest-lvlshift                                    \
		-restrictdir QS/regtest-md-lgvregion                                \
		-restrictdir QS/regtest-mp2-1                                       \
		-restrictdir QS/regtest-mp2-grad                                    \
		-restrictdir QS/regtest-optbas                                      \
		-restrictdir QS/regtest-ot-refine-3                                 \
		-restrictdir QS/regtest-pao-3                                       \
		-restrictdir QS/regtest-polar                                       \
		-restrictdir QS/regtest-properties/resp                             \
		-restrictdir QS/regtest-ps-implicit-2-3                             \
		-restrictdir QS/regtest-ri-mp2                                      \
		-restrictdir QS/regtest-ri-rpa                                      \
		-restrictdir QS/regtest-sccs-2                                      \
		-restrictdir QS/regtest-tddfpt                                      \
		-restrictdir QS/regtest-tddfpt-force-2                              \
		-restrictdir QS/regtest-tddfpt-lri                                  \
		-restrictdir SCPTB/regtest-1                                        \
		-restrictdir SE/regtest-3-1                                         \
		-restrictdir SWARM/regtest-glbopt-1)
endif

=== debian/tests/control ===
Depends: @, libint2-2 (>= 2.6.0-11)
Tests: testsuite.sh
Restrictions: allow-stderr
Architecture: !riscv64
